"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactCopyToClipboard = require("react-copy-to-clipboard");

var _Button = _interopRequireDefault(require("../Button"));

var _reactOuiIcons = _interopRequireDefault(require("react-oui-icons"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * @param {Object} props - Properties passed to component
 * @returns {ReactElement}
 * @private
 */
var CopyButton = function CopyButton(_ref) {
  var style = _ref.style,
      testSection = _ref.testSection,
      textToCopy = _ref.textToCopy,
      usesTextLabel = _ref.usesTextLabel,
      textLabel = _ref.textLabel,
      onCopy = _ref.onCopy;
  return _react["default"].createElement(_reactCopyToClipboard.CopyToClipboard, {
    text: textToCopy,
    onCopy: onCopy
  }, _react["default"].createElement(_Button["default"], {
    style: style === 'none' ? null : style,
    size: usesTextLabel ? 'tiny' : null,
    ariaLabel: "Copy code snippet",
    testSection: testSection ? "".concat(testSection, "-copy-button") : null
  }, usesTextLabel ? textLabel : _react["default"].createElement(_reactOuiIcons["default"], {
    name: "clipboard"
  })));
};

CopyButton.propTypes = {
  /** Function to perform when content is copied.
      This callback is passed as onCopy prop to CopyToClipboard component.
      onCopy(text, result)
      result (bool): Returns true if copied successfully, else false.
  */
  onCopy: _propTypes["default"].func,

  /** Style option for the button */
  style: _propTypes["default"].oneOf(['highlight', 'danger', 'danger-outline', 'outline', 'outline-reverse', 'plain', 'toggle', 'underline', 'unstyled', 'none']),

  /** Hook for automated JavaScript tests */
  testSection: _propTypes["default"].string,

  /** String label to use when usesTextLabel is true */
  textLabel: _propTypes["default"].string,

  /** The text or code that will be copied */
  textToCopy: _propTypes["default"].string.isRequired,

  /**
   * Whether or not this should use a string label
   * instead of an icon
   */
  usesTextLabel: _propTypes["default"].bool
};
CopyButton.defaultProps = {
  style: 'plain',
  usesTextLabel: false,
  textLabel: 'Copy'
};
var _default = CopyButton;
exports["default"] = _default;