"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _DraggableItem = _interopRequireDefault(require("./DraggableItem"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var DragAndDrop = function DragAndDrop(_ref) {
  var idForDroppableRegion = _ref.idForDroppableRegion,
      items = _ref.items,
      onBeforeCapture = _ref.onBeforeCapture,
      onDragEnd = _ref.onDragEnd,
      renderItem = _ref.renderItem,
      useCustomDragHandle = _ref.useCustomDragHandle;
  var updateOrderOfItems = (0, _react.useCallback)(function (result) {
    var destination = result.destination,
        source = result.source;

    if (!destination) {
      return;
    }

    if (destination.droppableId === source.droppableId && destination.index === source.index) {
      return;
    }

    var currentItems = items;
    var newOrderOfItems = Array.from(currentItems);

    var _newOrderOfItems$spli = newOrderOfItems.splice(source.index, 1),
        _newOrderOfItems$spli2 = _slicedToArray(_newOrderOfItems$spli, 1),
        removedItem = _newOrderOfItems$spli2[0];

    newOrderOfItems.splice(destination.index, 0, removedItem);
    onDragEnd(newOrderOfItems);
  }, [onDragEnd]);
  return _react["default"].createElement(_reactBeautifulDnd.DragDropContext, {
    onBeforeCapture: onBeforeCapture,
    onDragEnd: updateOrderOfItems
  }, _react["default"].createElement(_reactBeautifulDnd.Droppable, {
    droppableId: idForDroppableRegion
  }, function (provided) {
    return _react["default"].createElement("div", _extends({
      className: "oui-sortable",
      ref: provided.innerRef
    }, provided.droppableProps), _react["default"].createElement("ul", null, items.map(function (item, index) {
      return _react["default"].createElement(_DraggableItem["default"], {
        key: item.id,
        item: item,
        id: item.id,
        index: index,
        renderFunc: renderItem,
        useCustomDragHandle: useCustomDragHandle
      });
    })), provided.placeholder);
  }));
};

DragAndDrop.propTypes = {
  /**
   * ID used for this Droppable region
   */
  idForDroppableRegion: _propTypes["default"].string.isRequired,

  /**
   * Array of items to render as DraggableItems
   */
  items: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    id: _propTypes["default"].number
  })).isRequired,

  /**
   * Function to perform an action before item dimensions are captured
   */
  onBeforeCapture: _propTypes["default"].func,

  /**
   * Function to perform an action after dragging has finished
   */
  onDragEnd: _propTypes["default"].func,

  /**
   * Function used to render each draggable item
   */
  renderItem: _propTypes["default"].func.isRequired,

  /**
   * Whether or not items themselves will make use of the drag handle
   */
  useCustomDragHandle: _propTypes["default"].bool
};
DragAndDrop.defaultProps = {
  onBeforeCapture: function onBeforeCapture() {},
  onDragEnd: function onDragEnd() {},
  useCustomDragHandle: false
};
var _default = DragAndDrop;
exports["default"] = _default;