"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _HelpPopover = _interopRequireDefault(require("../HelpPopover"));

var _Row = _interopRequireDefault(require("../Form/Row"));

var _Item = _interopRequireDefault(require("../Form/Item"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Fieldset = function Fieldset(props) {
  var headerClasses = (0, _classnames["default"])({
    'push--bottom': props.titleSize === 'large',
    'push-half--bottom': props.titleSize === 'small',
    'gamma': props.titleSize === 'large',
    'epsilon': props.titleSize === 'small',
    'oui-label--required': props.isRequired
  });
  var fieldsetClasses = (0, _classnames["default"])({
    'push-triple--bottom': props.bottomSpacing,
    'flush--bottom': !props.bottomSpacing
  });
  return _react["default"].createElement("fieldset", {
    "data-test-section": props.testSection,
    className: fieldsetClasses
  }, props.title && _react["default"].createElement("legend", {
    className: headerClasses
  }, props.title, props.isOptional && _react["default"].createElement("label", {
    className: "oui-label__optional"
  }, "(Optional)"), props.helpIcon && _react["default"].createElement(_HelpPopover["default"], {
    popoverTitle: props.popoverTitle,
    horizontalAttachment: "left",
    verticalAttachment: "middle"
  }, _react["default"].createElement("p", null, props.popoverText))), props.description && _react["default"].createElement("div", {
    className: "push--bottom"
  }, props.description), props.children);
};

Fieldset.Row = _Row["default"];
Fieldset.Item = _Item["default"];
Fieldset.propTypes = {
  /** Adds spacing at the bottom. If used in a Form, make this to true. */
  bottomSpacing: _propTypes["default"].bool,

  /** Children components. Should be Fieldset.Row or Fieldset.Item for proper spacing */
  children: _propTypes["default"].node.isRequired,

  /** Description for Fieldset */
  description: _propTypes["default"].node,

  /** Indicates whether to include a help popover */
  helpIcon: _propTypes["default"].bool,

  /** Indicates whether to include the "optional" tag to the fieldset */
  isOptional: _propTypes["default"].bool,

  /** Indicates whether to include a required asterisk */
  isRequired: _propTypes["default"].bool,

  /** Text for popover */
  popoverText: _propTypes["default"].string,

  /** Title for popover */
  popoverTitle: _propTypes["default"].string,
  testSection: _propTypes["default"].string,

  /** Title for Fieldset */
  title: _propTypes["default"].string,

  /** Size of Fieldset title*/
  titleSize: _propTypes["default"].oneOf(['small', 'large'])
};
Fieldset.defaultProps = {
  bottomSpacing: true,
  titleSize: 'large'
};
var _default = Fieldset;
exports["default"] = _default;