"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Row = function Row(props) {
  var children = props.children.map(function (child, idx) {
    var rowClassname = (0, _classnames["default"])({
      'flex--1': props.isFullWidth,
      "push-double--right": idx < props.children.length - 1
    });
    return _react["default"].createElement("div", {
      key: idx,
      className: rowClassname
    }, child);
  });
  return _react["default"].createElement("div", {
    "data-test-section": props.testSection,
    className: "flex"
  }, children);
};

Row.propTypes = {
  children: _propTypes["default"].node.isRequired,

  /** Indicates whether items in the row should take up as much width as possible */
  isFullWidth: _propTypes["default"].bool,
  testSection: _propTypes["default"].string
};
var _default = Row;
exports["default"] = _default;