"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _HelpPopover = _interopRequireDefault(require("../../HelpPopover"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Section = function Section(props) {
  var headerClasses = (0, _classnames["default"])('push--bottom', {
    'oui-label--required': props.isRequired
  });
  return _react["default"].createElement("div", {
    "data-test-section": props.testSection,
    className: "soft-triple--bottom"
  }, props.title && _react["default"].createElement("h3", {
    className: headerClasses
  }, props.title, props.isOptional && _react["default"].createElement("label", {
    className: "oui-label__optional"
  }, "(Optional)"), props.helpIcon && _react["default"].createElement(_HelpPopover["default"], {
    popoverTitle: props.popoverTitle,
    horizontalAttachment: "left",
    verticalAttachment: "middle"
  }, _react["default"].createElement("p", null, props.popoverText))), props.description && _react["default"].createElement("div", {
    className: "push-double--bottom"
  }, props.description), props.children);
};

Section.propTypes = {
  children: _propTypes["default"].node.isRequired,

  /** Description for Form Section */
  description: _propTypes["default"].node,

  /** Indicates whether to include a help popover */
  helpIcon: _propTypes["default"].bool,

  /** Indicates whether to include the "optional" tag to the section */
  isOptional: _propTypes["default"].bool,

  /** Indicates whether to include a required asterisk */
  isRequired: _propTypes["default"].bool,

  /** Text for popover */
  popoverText: _propTypes["default"].string,

  /** Title for popover */
  popoverTitle: _propTypes["default"].string,
  testSection: _propTypes["default"].string,

  /** Title for Section */
  title: _propTypes["default"].string
};
var _default = Section;
exports["default"] = _default;