"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _HelpPopover = _interopRequireDefault(require("../HelpPopover"));

var _Section = _interopRequireDefault(require("./Section"));

var _Item = _interopRequireDefault(require("./Item"));

var _Row = _interopRequireDefault(require("./Row"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Form = function Form(props) {
  var formTitleClasses = (0, _classnames["default"])({
    'push--bottom': props.description,
    'push-double--bottom': !props.description
  });
  return _react["default"].createElement("form", {
    "data-test-section": props.testSection,
    className: "oui-form-fields"
  }, props.title && _react["default"].createElement("h2", {
    className: formTitleClasses
  }, props.title, props.helpIcon && _react["default"].createElement(_HelpPopover["default"], {
    popoverTitle: props.popoverTitle,
    horizontalAttachment: "left",
    verticalAttachment: "middle"
  }, _react["default"].createElement("p", null, props.popoverText))), props.description && _react["default"].createElement("p", {
    className: "push-double--bottom epsilon"
  }, props.description), props.children);
};

Form.Section = _Section["default"];
Form.Item = _Item["default"];
Form.Row = _Row["default"];
Form.propTypes = {
  children: _propTypes["default"].node.isRequired,

  /** Description for Form */
  description: _propTypes["default"].node,

  /** Indicates whether to include a help popover */
  helpIcon: _propTypes["default"].bool,

  /** Text for popover */
  popoverText: _propTypes["default"].string,

  /** Title for popover */
  popoverTitle: _propTypes["default"].string,
  testSection: _propTypes["default"].string,

  /** Title for Form */
  title: _propTypes["default"].string
};
var _default = Form;
exports["default"] = _default;