import _pt from "prop-types";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { isUndefined, noop } from 'lodash';
import React from 'react';
import classNames from 'classnames';
export var DropdownContents = React.forwardRef(function (_ref, ref) {
  var _ref$renderHeader = _ref.renderHeader,
      renderHeader = _ref$renderHeader === void 0 ? noop : _ref$renderHeader,
      props = _objectWithoutProperties(_ref, ["renderHeader"]);

  var styleProps = {};

  if (!isUndefined(props.isLoading)) {
    // Supports loading spinner over <ul> contents
    styleProps.position = 'relative';
  }

  if (props.minWidth) {
    styleProps.minWidth = props.minWidth;
  }

  if (props.canScroll) {
    styleProps.overflowY = 'visible';
    styleProps.maxHeight = 'none';
  }

  var wrapperClasses = classNames({
    nowrap: props.isNoWrap,
    'oui-dropdown': true,
    'oui-dropdown--right': props.direction === 'left',
    'oui-dropdown--up': props.direction === 'up'
  });
  var listClasses = classNames({
    'min-height--100': props.isLoading
  });
  return React.createElement("div", {
    ref: ref,
    className: wrapperClasses
  }, renderHeader(), React.createElement("ul", _extends({
    className: listClasses,
    role: "listbox",
    "aria-label": props.ariaLabel,
    style: styleProps
  }, props.testSection ? {
    'data-test-section': props.testSection
  } : {}), props.children));
});
DropdownContents.propTypes = {
  ariaLabel: _pt.string,
  canScroll: _pt.bool,
  direction: _pt.oneOf(['left', 'right', 'up']),
  isLoading: _pt.bool,
  isNoWrap: _pt.bool,
  minWidth: _pt.oneOfType([_pt.string, _pt.number]),
  renderHeader: _pt.func,
  testSection: _pt.string
};
DropdownContents.displayName = 'DropdownContents';
DropdownContents.defaultProps = {
  canScroll: false,
  direction: 'left',
  isLoading: undefined,
  isNoWrap: false,
  testSection: ''
};
export default DropdownContents;