import PropTypes from 'prop-types';
import React from 'react';
import classNames from 'classnames';

var Row = function Row(props) {
  var children = props.children.map(function (child, idx) {
    var rowClassname = classNames({
      'flex--1': props.isFullWidth,
      "push-double--right": idx < props.children.length - 1
    });
    return React.createElement("div", {
      key: idx,
      className: rowClassname
    }, child);
  });
  return React.createElement("div", {
    "data-test-section": props.testSection,
    className: "flex"
  }, children);
};

Row.propTypes = {
  children: PropTypes.node.isRequired,

  /** Indicates whether items in the row should take up as much width as possible */
  isFullWidth: PropTypes.bool,
  testSection: PropTypes.string
};
export default Row;