import PropTypes from 'prop-types';
import React from 'react';
import HelpPopover from '../../HelpPopover';
import classNames from 'classnames';

var Section = function Section(props) {
  var headerClasses = classNames('push--bottom', {
    'oui-label--required': props.isRequired
  });
  return React.createElement("div", {
    "data-test-section": props.testSection,
    className: "soft-triple--bottom"
  }, props.title && React.createElement("h3", {
    className: headerClasses
  }, props.title, props.isOptional && React.createElement("label", {
    className: "oui-label__optional"
  }, "(Optional)"), props.helpIcon && React.createElement(HelpPopover, {
    popoverTitle: props.popoverTitle,
    horizontalAttachment: "left",
    verticalAttachment: "middle"
  }, React.createElement("p", null, props.popoverText))), props.description && React.createElement("div", {
    className: "push-double--bottom"
  }, props.description), props.children);
};

Section.propTypes = {
  children: PropTypes.node.isRequired,

  /** Description for Form Section */
  description: PropTypes.node,

  /** Indicates whether to include a help popover */
  helpIcon: PropTypes.bool,

  /** Indicates whether to include the "optional" tag to the section */
  isOptional: PropTypes.bool,

  /** Indicates whether to include a required asterisk */
  isRequired: PropTypes.bool,

  /** Text for popover */
  popoverText: PropTypes.string,

  /** Title for popover */
  popoverTitle: PropTypes.string,
  testSection: PropTypes.string,

  /** Title for Section */
  title: PropTypes.string
};
export default Section;