import React from 'react';
import PropTypes from 'prop-types';

var NavList = function NavList(props) {
  return React.createElement("nav", {
    className: "sidenav__section",
    "data-test-section": props.testSection
  }, (props.label || props.rightLabel) && React.createElement("div", {
    className: "sidenav__section__title muted"
  }, React.createElement("h5", null, props.label), props.rightLabel && React.createElement("h6", null, props.rightLabel), props.popover), React.createElement("ul", {
    className: "nav-list"
  }, props.children));
};

NavList.propTypes = {
  /** Content to render within the list */
  children: PropTypes.node,

  /** Label to use for this section */
  label: PropTypes.string,

  /** Popover to display next to the label */
  popover: PropTypes.bool,

  /** Optional text to display to the right of the label */
  rightLabel: PropTypes.bool,

  /** Value used for testing via data-test-section attribute */
  testSection: PropTypes.bool
};
export default NavList;